' // BFUtility.vbs - Added utility functions


Function DeleteAll( sFolder )
	Dim oFolder
	Dim oFile
	Dim sStateStore
	
	oLogging.CreateEntry "Enter DeleteAll: Delete all contents of " & sFolder, LogTypeInfo
	
	sStateStore = ""
	If Len(oEnvironment.Item("OSDStateStorePath")) > 3 then
		If Mid(oEnvironment.Item("OSDStateStorePath"), 2, 1) = ":" then
			sStateStore = Mid(oEnvironment.Item("OSDStateStorePath"), 3)
		End if
	End if		
	
	For each oFolder in oFSO.GetFolder(sFolder & "\").Subfolders
			If sStateStore <> "" and Instr(3, oEnvironment.Item("OSDStateStorePath") & "\", Mid(oFolder.Path, 3) & "\", 1) <> 0 then
				oLogging.CreateEntry "Skipping " & oFolder.Path & " because it contains user state.", LogTypeInfo
			
			Else

				Select Case lcase(oFolder.Name)
				Case "minint", "recycler", "system volume information", "deploy", "drivers", "_smstasksequence", "smstslog", "sysprep"
					oLogging.CreateEntry "Skipping " & oFolder.Path, LogTypeInfo
				
				Case Else
					oShell.Run "cmd.exe /c rd /s /q """ & oFolder.Path & """", 0, true
					
					on error resume next
					if oFSO.FolderExists(oFolder.Path) then
					
						ResetFolderPermissions oFolder.Path
						
						oShell.Run "cmd.exe /c rd /s /q """ & oFolder.Path & """", 0, true

					End if
					on error goto 0

				End Select
			End if
		Next
	
End Function

Function ResetFolderPermissions( sPath )
	Dim oFile
	Dim oSD
	Dim stopFile
	
	oLogging.CreateEntry "Enter ResetFolderPermissions: Change security permissions for " & sPath, LogTypeInfo
	
	' // takeown to re-take ownership of folder
	oUtility.RunWithConsoleLogging("takeown.exe /F """ & sPath & """ /R /A /D Y")

	' // Use Win32_SecurityDescriptor and ChangeSecurityPermissionsEx to retrieve and change security permissions recursively
	Set oFile = objWMI.Get("CIM_Directory.Name=" & "'" & sPath & "'") 
	Set oSD = objWMI.Get("Win32_SecurityDescriptor").SpawnInstance_
	oFile.ChangeSecurityPermissionsEx oSD, 4, stopFile, true
	
	oLogging.CreateEntry "Exit ResetFolderPermissions", LogTypeInfo
		
End function